## adapterremoval 2.1.7

=== Makefile ===
###############################################################################
# Makefile options: Edit / comment / uncomment to change build behavior
#

# Installation destinations
PREFIX := /usr/local

# Default compilation flags
CXXFLAGS := -O3 -ansi -pedantic -Wall -Wextra
CXXFLAGS := ${CXXFLAGS} -Wcast-align -Wcast-qual -Wctor-dtor-privacy \
	-Wdisabled-optimization -Wformat=2 -Winit-self -Wold-style-cast \
	-Woverloaded-virtual -Wredundant-decls -Wsign-promo -Wstrict-overflow=5 \
	-Wswitch-default -Wundef -Weffc++

## Optional features; comment out or set to value other than 'yes' to disable

# Enable reading writing of gzip compressed files using libz.
ENABLE_GZIP_SUPPORT := yes

# Enable reading writing of bzip2 compressed files using libbz2.
ENABLE_BZIP2_SUPPORT := yes

# Enable multi-threading support using pthreads.
ENABLE_PTHREAD_SUPPORT := yes

# Hide individual commands during build; only shows summaries instead.
ENABLE_QUIET_BUILD := yes

# Use of colored output during build
ENABLE_COLOR_BUILD := yes


###############################################################################
# Makefile internals. Normally you do not need to touch these.

# Libraries required by AdapterRemoval
LIBRARIES :=

# Build directory; modified depending on build options
BDIR     := build/main


ifeq ($(strip ${ENABLE_QUIET_BUILD}),yes)
QUIET := @
endif

ifeq ($(strip ${ENABLE_COLOR_BUILD}),yes)
COLOR_YELLOW := "\033[0;33m"
COLOR_GREEN := "\033[0;32m"
COLOR_CYAN := "\033[0;36m"
COLOR_END := "\033[0m"
endif

ifeq ($(strip ${ENABLE_GZIP_SUPPORT}),yes)
$(info Building AdapterRemoval with gzip support: yes)
CXXFLAGS := ${CXXFLAGS} -DAR_GZIP_SUPPORT
LIBRARIES := ${LIBRARIES} -lz
BDIR := ${BDIR}_gz
else
$(info Building AdapterRemoval with gzip support: no)
endif

ifeq ($(strip ${ENABLE_BZIP2_SUPPORT}),yes)
$(info Building AdapterRemoval with bzip2 support: yes)
CXXFLAGS := ${CXXFLAGS} -DAR_BZIP2_SUPPORT
LIBRARIES := ${LIBRARIES} -lbz2
BDIR := ${BDIR}_bz2
else
$(info Building AdapterRemoval with bzip2 support: no)
endif

ifeq ($(strip ${ENABLE_PTHREAD_SUPPORT}),yes)
$(info Building AdapterRemoval with pthreads support: yes)
CXXFLAGS := ${CXXFLAGS} -DAR_PTHREAD_SUPPORT
LIBRARIES := ${LIBRARIES} -lpthread
BDIR := ${BDIR}_pthreads
else
$(info Building AdapterRemoval with pthreads support: no)
endif


PROG     := AdapterRemoval
LIBNAME  := libadapterremoval
LIBOBJS  := $(BDIR)/adapterset.o \
            $(BDIR)/alignment.o \
            $(BDIR)/argparse.o \
            $(BDIR)/debug.o \
            $(BDIR)/demultiplex.o \
            $(BDIR)/fastq.o \
            $(BDIR)/fastq_enc.o \
            $(BDIR)/fastq_io.o \
            $(BDIR)/linereader.o \
            $(BDIR)/main_adapter_id.o \
            $(BDIR)/main_adapter_rm.o \
            $(BDIR)/scheduler.o \
            $(BDIR)/strutils.o \
            $(BDIR)/threads.o \
            $(BDIR)/timer.o \
            $(BDIR)/userconfig.o
OBJS     := ${LIBOBJS} $(BDIR)/main.o
DFILES   := $(OBJS:.o=.deps)


.PHONY: all install clean test clean_tests static

all: build/$(PROG) build/$(PROG).1

# Clean
clean: clean_tests
	@echo $(COLOR_GREEN)"Cleaning ..."$(COLOR_END)
	$(QUIET) rm -f build/$(PROG) build/$(PROG).1
	$(QUIET) rm -rvf $(BDIR)

# Install
install: build/$(PROG) build/$(PROG).1
	@echo $(COLOR_GREEN)"Installing AdapterRemoval .."$(COLOR_END)
	@echo $(COLOR_GREEN)"  .. binary into ${PREFIX}/bin/"$(COLOR_END)
	$(QUIET) mkdir -p ${PREFIX}/bin/
	$(QUIET) mv -f build/$(PROG) ${PREFIX}/bin/
	$(QUIET) chmod a+x ${PREFIX}/bin/$(PROG)

	@echo $(COLOR_GREEN)"  .. man-page into ${PREFIX}/share/man/man1/"$(COLOR_END)
	$(QUIET) mkdir -p ${PREFIX}/share/man/man1/
	$(QUIET) mv -f build/$(PROG).1 ${PREFIX}/share/man/man1/
	$(QUIET) chmod a+r ${PREFIX}/share/man/man1/$(PROG).1

	@echo $(COLOR_GREEN)"  .. README into ${PREFIX}/share/adapterremoval/"$(COLOR_END)
	$(QUIET) mkdir -p ${PREFIX}/share/adapterremoval/
	$(QUIET) cp -a README.md ${PREFIX}/share/adapterremoval/
	$(QUIET) chmod a+r ${PREFIX}/share/adapterremoval/README.md

	@echo $(COLOR_GREEN)"  .. examples into ${PREFIX}/share/adapterremoval/examples/"$(COLOR_END)
	$(QUIET) mkdir -p ${PREFIX}/share/adapterremoval/examples/
	$(QUIET) cp -a examples/*.* ${PREFIX}/share/adapterremoval/examples/
	$(QUIET) chmod a+r ${PREFIX}/share/adapterremoval/examples/*.*

static: build/$(LIBNAME).a

# Object files
$(BDIR)/%.o: src/%.cc
	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
	$(QUIET) mkdir -p $(BDIR)
	$(QUIET) $(CXX) $(CXXFLAGS) -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<

# Executable
build/$(PROG): $(OBJS)
	@echo $(COLOR_GREEN)"Linking executable '$@'"$(COLOR_END)
	$(QUIET) $(CXX) $(CXXFLAGS) $^ ${LIBRARIES} -o $@

# Static library
build/$(LIBNAME).a: $(LIBOBJS)
	@echo $(COLOR_GREEN)"Linking static library '$@'"$(COLOR_END)
	$(AR) rcs build/$(LIBNAME).a $(LIBOBJS)

build/%.1: %.pod
	@echo $(COLOR_GREEN)"Constructing man-page '$@' from '$<'"$(COLOR_END)
	$(QUIET) mkdir -p $(BDIR)
	$(QUIET) pod2man $< > $@

# Automatic header depencencies
-include $(DFILES)


#
# Unit testing
#
TEST_DIR := build/tests
TEST_OBJS := $(TEST_DIR)/alignment.o \
             $(TEST_DIR)/alignment_test.o \
             $(TEST_DIR)/argparse.o \
             $(TEST_DIR)/argparse_test.o \
             $(TEST_DIR)/debug.o \
             $(TEST_DIR)/fastq.o \
             $(TEST_DIR)/fastq_enc.o \
             $(TEST_DIR)/fastq_test.o \
             $(TEST_DIR)/strutils.o \
             $(TEST_DIR)/strutils_test.o
TEST_DEPS := $(TEST_OBJS:.o=.deps)

GTEST_DIR := googletest-release-1.7.0
GTEST_OBJS := $(TEST_DIR)/gtest-all.o $(TEST_DIR)/gtest_main.o
GTEST_LIB :=$(TEST_DIR)/libgtest.a

TEST_CXXFLAGS := -isystem $(GTEST_DIR)/include -I$(GTEST_DIR) -Isrc -DAR_TEST_BUILD
GTEST_CXXFLAGS := $(TEST_CXXFLAGS)

test: $(TEST_DIR)/main
	@echo $(COLOR_GREEN)"Running tests"$(COLOR_END)
	$(QUIET) $< --gtest_print_time=0 --gtest_shuffle

clean_tests:
	@echo $(COLOR_GREEN)"Cleaning tests ..."$(COLOR_END)
	$(QUIET) rm -rvf $(TEST_DIR)

$(TEST_DIR)/main: $(GTEST_LIB) $(TEST_OBJS)
	@echo $(COLOR_GREEN)"Linking executable $@\033[0m"$(COLOR_END)
	$(QUIET) $(CXX) $(CXXFLAGS) -pthread $^ -o $@

$(TEST_DIR)/libgtest.a: $(GTEST_OBJS)
	@echo $(COLOR_GREEN)"Linking GTest library '$@'"$(COLOR_END)
	$(QUIET) ar -rv $@ $^

$(TEST_DIR)/%.o: tests/%.cc
	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
	mkdir -p $(TEST_DIR)
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<

$(TEST_DIR)/%.o: src/%.cc
	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
	mkdir -p $(TEST_DIR)
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<

$(TEST_DIR)/gtest%.o: $(GTEST_DIR)/src/gtest%.cc
	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
	$(QUIET) mkdir -p $(TEST_DIR)
	$(QUIET) $(CXX) $(GTEST_CXXFLAGS) -pthread -c $< -o $@

.PRECIOUS: $(GTEST_DIR)/src/gtest%.cc
$(GTEST_DIR)/src/gtest%.cc: googletest-release-1.7.0.zip
	$(QUIET) if ! test -e "$@"; \
	then \
		echo $(COLOR_CYAN)"Unpacking Google Test library"$(COLOR_END); \
		unzip -qo googletest-release-1.7.0.zip; \
	fi

googletest-release-1.7.0.zip:
ifneq ("$(shell which wget)", "")
	@echo $(COLOR_CYAN)"Fetching Google Test library using wget"$(COLOR_END)
	$(QUIET) wget -q https://github.com/google/googletest/archive/release-1.7.0.zip -O googletest-release-1.7.0.zip
else ifneq ("$(shell which curl)", "")
	@echo $(COLOR_CYAN)"Fetching Google Test library using curl"$(COLOR_END)
	$(QUIET) curl -L https://github.com/google/googletest/archive/release-1.7.0.zip -o googletest-release-1.7.0.zip
else
	@echo $(COLOR_YELLOW)"To run tests, first download and unpack GoogleTest 1.7.0 in this folder:"$(COLOR_END)
	@echo $(COLOR_YELLOW)"  $$ wget https://github.com/google/googletest/archive/release-1.7.0.zip -O googletest-release-1.7.0.zip"$(COLOR_END)
	@echo $(COLOR_YELLOW)"  $$ unzip googletest-release-1.7.0.zip"$(COLOR_END)
	@exit 1
endif

# Automatic header dependencies for tests
-include $(TEST_DEPS)

=== debian/changelog ===
adapterremoval (2.1.7-1) unstable; urgency=medium

  * Initial release (Closes: #832754)

 -- Andreas Tille <tille@debian.org>  Thu, 28 Jul 2016 16:40:07 +0200

=== debian/control ===
Source: adapterremoval
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               zlib1g-dev,
               libbz2-dev,
               libgtest-dev,
               python-markdown
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/adapterremoval.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/adapterremoval.git
Homepage: https://github.com/MikkelSchubert/adapterremoval

Package: adapterremoval
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: rapid adapter trimming, identification, and read merging of gene sequences
 This program searches for and removes remnant adapter sequences from High-
 Throughput Sequencing (HTS) data and (optionally) trims low quality
 bases from the 3' end of reads following adapter removal. AdapterRemoval
 can analyze both single end and paired end data, and can be used to
 merge overlapping paired-ended reads into (longer) consensus sequences.
 Additionally, the AdapterRemoval may be used to recover a consensus
 adapter sequence for paired-ended data, for which this information is
 not available.

Package: adapterremoval-examples
Architecture: all
Depends: ${misc:Depends}
Description: rapid adapter trimming, identification, and read merging (example data)
 This program searches for and removes remnant adapter sequences from High-
 Throughput Sequencing (HTS) data and (optionally) trims low quality
 bases from the 3' end of reads following adapter removal. AdapterRemoval
 can analyze both single end and paired end data, and can be used to
 merge overlapping paired-ended reads into (longer) consensus sequences.
 Additionally, the AdapterRemoval may be used to recover a consensus
 adapter sequence for paired-ended data, for which this information is
 not available.
 .
 This package provides the example data.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	markdown_py -f README.html README.md

override_dh_auto_test:
	# dh_auto_test
	echo "*********** Needs adapting to libgtest-dev. ***************"

override_dh_auto_install:
	make PREFIX=$(CURDIR)/debian/$(DEBPKGNAME)/usr
	# Hmmm, this does nothing ...

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

## adapterremoval 2.2.0

=== Makefile ===
--- 
+++ 
@@ -6,52 +6,48 @@
 PREFIX := /usr/local
 
 # Default compilation flags
-CXXFLAGS := -O3 -ansi -pedantic -Wall -Wextra
-CXXFLAGS := ${CXXFLAGS} -Wcast-align -Wcast-qual -Wctor-dtor-privacy \
-	-Wdisabled-optimization -Wformat=2 -Winit-self -Wold-style-cast \
-	-Woverloaded-virtual -Wredundant-decls -Wsign-promo -Wstrict-overflow=5 \
-	-Wswitch-default -Wundef -Weffc++
+CXXFLAGS := ${CXXFLAGS} -std=c++11 -O3
 
 ## Optional features; comment out or set to value other than 'yes' to disable
 
 # Enable reading writing of gzip compressed files using libz.
-ENABLE_GZIP_SUPPORT := yes
+GZIP_SUPPORT := yes
 
 # Enable reading writing of bzip2 compressed files using libbz2.
-ENABLE_BZIP2_SUPPORT := yes
-
-# Enable multi-threading support using pthreads.
-ENABLE_PTHREAD_SUPPORT := yes
+BZIP2_SUPPORT := yes
 
 # Hide individual commands during build; only shows summaries instead.
-ENABLE_QUIET_BUILD := yes
+QUIET_BUILD := yes
 
 # Use of colored output during build
-ENABLE_COLOR_BUILD := yes
+COLOR_BUILD := yes
+
+# Debug build; adds warnings and debugging symbols
+DEBUG_BUILD := no
 
 
 ###############################################################################
 # Makefile internals. Normally you do not need to touch these.
 
 # Libraries required by AdapterRemoval
-LIBRARIES :=
+LIBRARIES := -pthread
 
 # Build directory; modified depending on build options
 BDIR     := build/main
 
 
-ifeq ($(strip ${ENABLE_QUIET_BUILD}),yes)
+ifeq ($(strip ${QUIET_BUILD}),yes)
 QUIET := @
 endif
 
-ifeq ($(strip ${ENABLE_COLOR_BUILD}),yes)
+ifeq ($(strip ${COLOR_BUILD}),yes)
 COLOR_YELLOW := "\033[0;33m"
 COLOR_GREEN := "\033[0;32m"
 COLOR_CYAN := "\033[0;36m"
 COLOR_END := "\033[0m"
 endif
 
-ifeq ($(strip ${ENABLE_GZIP_SUPPORT}),yes)
+ifeq ($(strip ${GZIP_SUPPORT}),yes)
 $(info Building AdapterRemoval with gzip support: yes)
 CXXFLAGS := ${CXXFLAGS} -DAR_GZIP_SUPPORT
 LIBRARIES := ${LIBRARIES} -lz
@@ -60,7 +56,7 @@
 $(info Building AdapterRemoval with gzip support: no)
 endif
 
-ifeq ($(strip ${ENABLE_BZIP2_SUPPORT}),yes)
+ifeq ($(strip ${BZIP2_SUPPORT}),yes)
 $(info Building AdapterRemoval with bzip2 support: yes)
 CXXFLAGS := ${CXXFLAGS} -DAR_BZIP2_SUPPORT
 LIBRARIES := ${LIBRARIES} -lbz2
@@ -69,15 +65,15 @@
 $(info Building AdapterRemoval with bzip2 support: no)
 endif
 
-ifeq ($(strip ${ENABLE_PTHREAD_SUPPORT}),yes)
-$(info Building AdapterRemoval with pthreads support: yes)
-CXXFLAGS := ${CXXFLAGS} -DAR_PTHREAD_SUPPORT
-LIBRARIES := ${LIBRARIES} -lpthread
-BDIR := ${BDIR}_pthreads
-else
-$(info Building AdapterRemoval with pthreads support: no)
-endif
-
+ifeq ($(strip ${DEBUG_BUILD}), yes)
+$(info Building AdapterRemoval with debug information: yes)
+CXXFLAGS := ${CXXFLAGS} -g -pedantic -Wall -Wextra -Wcast-align -Wcast-qual \
+	-Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self \
+	-Wold-style-cast -Woverloaded-virtual -Wredundant-decls -Wsign-promo \
+	-Wstrict-overflow=2 -Wswitch-default -Wundef -Weffc++ -Wdeprecated
+else
+$(info Building AdapterRemoval with debug information: no)
+endif
 
 PROG     := AdapterRemoval
 LIBNAME  := libadapterremoval
@@ -92,23 +88,27 @@
             $(BDIR)/linereader.o \
             $(BDIR)/main_adapter_id.o \
             $(BDIR)/main_adapter_rm.o \
+            $(BDIR)/main_demultiplex.o \
             $(BDIR)/scheduler.o \
             $(BDIR)/strutils.o \
             $(BDIR)/threads.o \
             $(BDIR)/timer.o \
+            $(BDIR)/trimmed_reads.o \
             $(BDIR)/userconfig.o
 OBJS     := ${LIBOBJS} $(BDIR)/main.o
 DFILES   := $(OBJS:.o=.deps)
 
 
-.PHONY: all install clean test clean_tests static
+.PHONY: all install clean test clean_tests static validate validation
 
 all: build/$(PROG) build/$(PROG).1
+
+everything: all static test validation
 
 # Clean
 clean: clean_tests
 	@echo $(COLOR_GREEN)"Cleaning ..."$(COLOR_END)
-	$(QUIET) rm -f build/$(PROG) build/$(PROG).1
+	$(QUIET) rm -f build/$(PROG) build/$(PROG).1 build/$(LIBNAME).a
 	$(QUIET) rm -rvf $(BDIR)
 
 # Install
@@ -140,13 +140,13 @@
 $(BDIR)/%.o: src/%.cc
 	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
 	$(QUIET) mkdir -p $(BDIR)
-	$(QUIET) $(CXX) $(CXXFLAGS) -c -o $@ $<
+	$(QUIET) $(CXX) $(CXXFLAGS) -pthread -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
 # Executable
 build/$(PROG): $(OBJS)
 	@echo $(COLOR_GREEN)"Linking executable '$@'"$(COLOR_END)
-	$(QUIET) $(CXX) $(CXXFLAGS) $^ ${LIBRARIES} -o $@
+	$(QUIET) $(CXX) $(CXXFLAGS) ${LDFLAGS} $^ ${LIBRARIES} -o $@
 
 # Static library
 build/$(LIBNAME).a: $(LIBOBJS)
@@ -180,7 +180,7 @@
 
 GTEST_DIR := googletest-release-1.7.0
 GTEST_OBJS := $(TEST_DIR)/gtest-all.o $(TEST_DIR)/gtest_main.o
-GTEST_LIB :=$(TEST_DIR)/libgtest.a
+GTEST_LIB := $(TEST_DIR)/libgtest.a
 
 TEST_CXXFLAGS := -isystem $(GTEST_DIR)/include -I$(GTEST_DIR) -Isrc -DAR_TEST_BUILD
 GTEST_CXXFLAGS := $(TEST_CXXFLAGS)
@@ -194,8 +194,8 @@
 	$(QUIET) rm -rvf $(TEST_DIR)
 
 $(TEST_DIR)/main: $(GTEST_LIB) $(TEST_OBJS)
-	@echo $(COLOR_GREEN)"Linking executable $@\033[0m"$(COLOR_END)
-	$(QUIET) $(CXX) $(CXXFLAGS) -pthread $^ -o $@
+	@echo $(COLOR_GREEN)"Linking executable $@"$(COLOR_END)
+	$(QUIET) $(CXX) $(CXXFLAGS) ${LIBRARIES} $^ -o $@
 
 $(TEST_DIR)/libgtest.a: $(GTEST_OBJS)
 	@echo $(COLOR_GREEN)"Linking GTest library '$@'"$(COLOR_END)
@@ -203,20 +203,20 @@
 
 $(TEST_DIR)/%.o: tests/%.cc
 	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
-	mkdir -p $(TEST_DIR)
+	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
 $(TEST_DIR)/%.o: src/%.cc
 	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
-	mkdir -p $(TEST_DIR)
+	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
 $(TEST_DIR)/gtest%.o: $(GTEST_DIR)/src/gtest%.cc
 	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
 	$(QUIET) mkdir -p $(TEST_DIR)
-	$(QUIET) $(CXX) $(GTEST_CXXFLAGS) -pthread -c $< -o $@
+	$(QUIET) $(CXX) $(GTEST_CXXFLAGS) -c $< -o $@
 
 .PRECIOUS: $(GTEST_DIR)/src/gtest%.cc
 $(GTEST_DIR)/src/gtest%.cc: googletest-release-1.7.0.zip
@@ -240,5 +240,20 @@
 	@exit 1
 endif
 
+
+#
+# Validation
+#
+VALIDATION_BDIR=build/validation
+VALIDATION_SDIR=validation
+
+validate: build/$(PROG)
+	@echo $(COLOR_CYAN)"Validating AdapterRemoval results"$(COLOR_END)
+	@mkdir -p $(VALIDATION_BDIR)
+	@./validation/run $(VALIDATION_BDIR) $(VALIDATION_SDIR)
+
+validation: validate
+
+
 # Automatic header dependencies for tests
 -include $(TEST_DEPS)

=== debian/changelog ===
adapterremoval (2.2.0-1) unstable; urgency=medium

  [ Kevin Murray ]
  * Team upload
  * New upstream version 2.2.0 (Closes: #846664)
  * Refresh patches

  [ Andreas Tille ]
  * Fix spelling
  * DEP3 for benchmarking patches

 -- Kevin Murray <spam@kdmurray.id.au>  Sun, 04 Dec 2016 17:22:09 +0100

=== debian/control ===
--- 
+++ 
@@ -41,3 +41,25 @@
  not available.
  .
  This package provides the example data.
+
+#Package: adapter-benchmark
+#Architecture: all
+#Depends: ${misc:Depends},
+#         python,
+#         adapterremoval,
+#         cutadapt,
+#         ea-utils,
+#         flexbar,
+#         scythe,
+#         trimmomatic
+#Suggests: pirs
+#Description: benchmarking trimming adapters gene sequences
+# The program adapterremoval contains a benchmarking suite for differen
+# programs fullfilling a similar purpose to searche for and remove
+# remnant adapter sequences from High-Throughput Sequencing (HTS) data
+# and trims low quality bases from the 3' end of reads following adapter
+# removal.
+# .
+# This package provides the test suite adapted to the use with all
+# Debian packaged programs which are: adapterremoval, cutadapt, flexbar,
+# scythe and trimmomatic.

=== debian/rules ===
--- 
+++ 
@@ -23,3 +23,7 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs CHANGES.md
+
+override_dh_fixperms:
+	dh_fixperms
+	find debian -name benchmark.sh -exec chmod +x \{\} \;

=== debian/watch ===
version=3

https://github.com/MikkelSchubert/adapterremoval/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## adapterremoval 2.2.2

=== Makefile ===
--- 
+++ 
@@ -10,12 +10,6 @@
 
 ## Optional features; comment out or set to value other than 'yes' to disable
 
-# Enable reading writing of gzip compressed files using libz.
-GZIP_SUPPORT := yes
-
-# Enable reading writing of bzip2 compressed files using libbz2.
-BZIP2_SUPPORT := yes
-
 # Hide individual commands during build; only shows summaries instead.
 QUIET_BUILD := yes
 
@@ -25,12 +19,14 @@
 # Debug build; adds warnings and debugging symbols
 DEBUG_BUILD := no
 
+# Include coverage instrumentation in build
+COVERAGE := no
 
 ###############################################################################
 # Makefile internals. Normally you do not need to touch these.
 
 # Libraries required by AdapterRemoval
-LIBRARIES := -pthread
+LIBRARIES := -pthread -lz -lbz2
 
 # Build directory; modified depending on build options
 BDIR     := build/main
@@ -47,22 +43,12 @@
 COLOR_END := "\033[0m"
 endif
 
-ifeq ($(strip ${GZIP_SUPPORT}),yes)
-$(info Building AdapterRemoval with gzip support: yes)
-CXXFLAGS := ${CXXFLAGS} -DAR_GZIP_SUPPORT
-LIBRARIES := ${LIBRARIES} -lz
-BDIR := ${BDIR}_gz
+ifeq ($(strip ${COVERAGE}), yes)
+$(info Building AdapterRemoval with coverage instrumentation: yes)
+CXXFLAGS := ${CXXFLAGS} --coverage
+DEBUG_BUILD := yes
 else
-$(info Building AdapterRemoval with gzip support: no)
-endif
-
-ifeq ($(strip ${BZIP2_SUPPORT}),yes)
-$(info Building AdapterRemoval with bzip2 support: yes)
-CXXFLAGS := ${CXXFLAGS} -DAR_BZIP2_SUPPORT
-LIBRARIES := ${LIBRARIES} -lbz2
-BDIR := ${BDIR}_bz2
-else
-$(info Building AdapterRemoval with bzip2 support: no)
+$(info Building AdapterRemoval with coverage instrumentation: no)
 endif
 
 ifeq ($(strip ${DEBUG_BUILD}), yes)
@@ -86,6 +72,7 @@
             $(BDIR)/fastq_enc.o \
             $(BDIR)/fastq_io.o \
             $(BDIR)/linereader.o \
+            $(BDIR)/linereader_joined.o \
             $(BDIR)/main_adapter_id.o \
             $(BDIR)/main_adapter_rm.o \
             $(BDIR)/main_demultiplex.o \
@@ -109,6 +96,7 @@
 clean: clean_tests
 	@echo $(COLOR_GREEN)"Cleaning ..."$(COLOR_END)
 	$(QUIET) rm -f build/$(PROG) build/$(PROG).1 build/$(LIBNAME).a
+	$(QUIET) rm -rvf build/validation
 	$(QUIET) rm -rvf $(BDIR)
 
 # Install
@@ -137,24 +125,24 @@
 static: build/$(LIBNAME).a
 
 # Object files
-$(BDIR)/%.o: src/%.cc
-	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
+$(BDIR)/%.o: src/%.cpp
+	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(BDIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) -pthread -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
 # Executable
 build/$(PROG): $(OBJS)
-	@echo $(COLOR_GREEN)"Linking executable '$@'"$(COLOR_END)
+	@echo $(COLOR_GREEN)"Linking executable $@"$(COLOR_END)
 	$(QUIET) $(CXX) $(CXXFLAGS) ${LDFLAGS} $^ ${LIBRARIES} -o $@
 
 # Static library
 build/$(LIBNAME).a: $(LIBOBJS)
-	@echo $(COLOR_GREEN)"Linking static library '$@'"$(COLOR_END)
+	@echo $(COLOR_GREEN)"Linking static library $@"$(COLOR_END)
 	$(AR) rcs build/$(LIBNAME).a $(LIBOBJS)
 
 build/%.1: %.pod
-	@echo $(COLOR_GREEN)"Constructing man-page '$@' from '$<'"$(COLOR_END)
+	@echo $(COLOR_GREEN)"Constructing man-page $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(BDIR)
 	$(QUIET) pod2man $< > $@
 
@@ -172,17 +160,18 @@
              $(TEST_DIR)/argparse_test.o \
              $(TEST_DIR)/debug.o \
              $(TEST_DIR)/fastq.o \
+             $(TEST_DIR)/fastq_test.o \
              $(TEST_DIR)/fastq_enc.o \
-             $(TEST_DIR)/fastq_test.o \
+             $(TEST_DIR)/fastq_enc_test.o \
              $(TEST_DIR)/strutils.o \
              $(TEST_DIR)/strutils_test.o
 TEST_DEPS := $(TEST_OBJS:.o=.deps)
 
-GTEST_DIR := googletest-release-1.7.0
+GTEST_DIR := googletest-release-1.8.0/googletest
 GTEST_OBJS := $(TEST_DIR)/gtest-all.o $(TEST_DIR)/gtest_main.o
 GTEST_LIB := $(TEST_DIR)/libgtest.a
 
-TEST_CXXFLAGS := -isystem $(GTEST_DIR)/include -I$(GTEST_DIR) -Isrc -DAR_TEST_BUILD
+TEST_CXXFLAGS := -isystem $(GTEST_DIR)/include -I$(GTEST_DIR) -Isrc -DAR_TEST_BUILD -g
 GTEST_CXXFLAGS := $(TEST_CXXFLAGS)
 
 test: $(TEST_DIR)/main
@@ -198,45 +187,45 @@
 	$(QUIET) $(CXX) $(CXXFLAGS) ${LIBRARIES} $^ -o $@
 
 $(TEST_DIR)/libgtest.a: $(GTEST_OBJS)
-	@echo $(COLOR_GREEN)"Linking GTest library '$@'"$(COLOR_END)
+	@echo $(COLOR_GREEN)"Linking GTest library $@"$(COLOR_END)
 	$(QUIET) ar -rv $@ $^
 
-$(TEST_DIR)/%.o: tests/%.cc
+$(TEST_DIR)/%.o: tests/%.cpp
 	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
-$(TEST_DIR)/%.o: src/%.cc
+$(TEST_DIR)/%.o: src/%.cpp
 	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
 $(TEST_DIR)/gtest%.o: $(GTEST_DIR)/src/gtest%.cc
-	@echo $(COLOR_CYAN)"Building '$@' from '$<'"$(COLOR_END)
+	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(GTEST_CXXFLAGS) -c $< -o $@
 
 .PRECIOUS: $(GTEST_DIR)/src/gtest%.cc
-$(GTEST_DIR)/src/gtest%.cc: googletest-release-1.7.0.zip
+$(GTEST_DIR)/src/gtest%.cc: googletest-release-1.8.0.zip
 	$(QUIET) if ! test -e "$@"; \
 	then \
 		echo $(COLOR_CYAN)"Unpacking Google Test library"$(COLOR_END); \
-		unzip -qo googletest-release-1.7.0.zip; \
+		unzip -qo googletest-release-1.8.0.zip; \
 	fi
 
-googletest-release-1.7.0.zip:
+googletest-release-1.8.0.zip:
 ifneq ("$(shell which wget)", "")
 	@echo $(COLOR_CYAN)"Fetching Google Test library using wget"$(COLOR_END)
-	$(QUIET) wget -q https://github.com/google/googletest/archive/release-1.7.0.zip -O googletest-release-1.7.0.zip
+	$(QUIET) wget -q https://github.com/google/googletest/archive/release-1.8.0.zip -O googletest-release-1.8.0.zip
 else ifneq ("$(shell which curl)", "")
 	@echo $(COLOR_CYAN)"Fetching Google Test library using curl"$(COLOR_END)
-	$(QUIET) curl -L https://github.com/google/googletest/archive/release-1.7.0.zip -o googletest-release-1.7.0.zip
+	$(QUIET) curl -L https://github.com/google/googletest/archive/release-1.8.0.zip -o googletest-release-1.8.0.zip
 else
-	@echo $(COLOR_YELLOW)"To run tests, first download and unpack GoogleTest 1.7.0 in this folder:"$(COLOR_END)
-	@echo $(COLOR_YELLOW)"  $$ wget https://github.com/google/googletest/archive/release-1.7.0.zip -O googletest-release-1.7.0.zip"$(COLOR_END)
-	@echo $(COLOR_YELLOW)"  $$ unzip googletest-release-1.7.0.zip"$(COLOR_END)
+	@echo $(COLOR_YELLOW)"To run tests, first download and unpack GoogleTest 1.8.0 in this folder:"$(COLOR_END)
+	@echo $(COLOR_YELLOW)"  $$ wget https://github.com/google/googletest/archive/release-1.8.0.zip -O googletest-release-1.8.0.zip"$(COLOR_END)
+	@echo $(COLOR_YELLOW)"  $$ unzip googletest-release-1.8.0.zip"$(COLOR_END)
 	@exit 1
 endif

=== examples/Makefile ===

TARGETS := single_end paired_end phred_64_encoded phred_33_encoded \
	collapsed_q50 multiple_adapters identify_adapters \
	interleaved_input interleaved_output interleaved_input_and_output \
	demultiplexing demultiplexing_only

.PHONY: all ${TARGETS}

all: ${TARGETS}


single_end:
	AdapterRemoval --file1 reads_1.fq --basename output_single --trimns --trimqualities --gzip

paired_end:
	AdapterRemoval --file1 reads_1.fq --file2 reads_2.fq --basename output_paired --trimns --trimqualities --collapse

interleaved_input:
	AdapterRemoval --interleaved-input --file1 interleaved.fq --basename output_interleaved_input

interleaved_output:
	AdapterRemoval --interleaved-output --file1 reads_1.fq --file2 reads_2.fq --basename output_interleaved_output

interleaved_input_and_output:
	AdapterRemoval --interleaved --file1 interleaved.fq --basename output_interleaved_both

phred_64_encoded:
	AdapterRemoval --qualitybase 64 --file1 reads_q64.fq --basename output_phred_64

phred_33_encoded:
	AdapterRemoval --qualitybase 64 --qualitybase-output 33 --file1 reads_q64.fq --basename output_phred_33

collapsed_q50:
	AdapterRemoval --qualitymax 50 --file1 reads_1.fq --file2 reads_2.fq --collapse --basename output_collapsed_q50

multiple_adapters:
	AdapterRemoval --file1 reads_1.fq --file2 reads_2.fq --basename output_multi --trimns --trimqualities --collapse --adapter-list adapters.txt

identify_adapters:
	AdapterRemoval --identify-adapters --file1 reads_1.fq --file2 reads_2.fq

demultiplexing:
	AdapterRemoval --file1 demux_1.fq --file2 demux_2.fq --basename output_demux --barcode-list barcodes.txt

demultiplexing_only:
	AdapterRemoval --file1 demux_1.fq --file2 demux_2.fq --basename output_only_demux --barcode-list barcodes.txt --demultiplex-only

=== debian/changelog ===
adapterremoval (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2

 -- Kevin Murray <kdmfoss@gmail.com>  Tue, 18 Jul 2017 09:37:44 +1000

adapterremoval (2.2.1a-1) unstable; urgency=medium

  * New upstream version (adapt patches)
  * Enable letters in watch file expression
  * Standards-Version: 4.0.0 (no changes needed)
  * d/rules: use DEB_SOURCE

 -- Andreas Tille <tille@debian.org>  Mon, 17 Jul 2017 13:02:02 +0200

adapterremoval (2.2.1-1) unstable; urgency=medium

  * New upstream version
  * Drop spelling patch
  * debhelper 10
  * verified watch file and set version=4

 -- Andreas Tille <tille@debian.org>  Thu, 22 Jun 2017 09:08:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: adapterremoval
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                zlib1g-dev,
                libbz2-dev,
                libgtest-dev,
                python-markdown
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/adapterremoval.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/adapterremoval.git
 Homepage: https://github.com/MikkelSchubert/adapterremoval

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
+include /usr/share/dpkg/default.mk
 
 %:
 	dh $@
@@ -18,7 +18,7 @@
 	echo "*********** Needs adapting to libgtest-dev. ***************"
 
 override_dh_auto_install:
-	make PREFIX=$(CURDIR)/debian/$(DEBPKGNAME)/usr
+	make PREFIX=$(CURDIR)/debian/$(DEB_SOURCE)/usr
 	# Hmmm, this does nothing ...
 
 override_dh_installchangelogs:

## adapterremoval 2.2.3

=== Makefile ===
--- 
+++ 
@@ -86,21 +86,21 @@
 DFILES   := $(OBJS:.o=.deps)
 
 
-.PHONY: all install clean test clean_tests static validate validation
-
-all: build/$(PROG) build/$(PROG).1
-
-everything: all static test validation
+.PHONY: all install clean test clean_tests static regression docs
+
+all: build/$(PROG)
+
+everything: all static test regression docs
 
 # Clean
-clean: clean_tests
+clean: clean_tests clean_docs
 	@echo $(COLOR_GREEN)"Cleaning ..."$(COLOR_END)
-	$(QUIET) rm -f build/$(PROG) build/$(PROG).1 build/$(LIBNAME).a
-	$(QUIET) rm -rvf build/validation
+	$(QUIET) rm -f build/$(PROG) build/$(LIBNAME).a
+	$(QUIET) rm -rvf build/regression
 	$(QUIET) rm -rvf $(BDIR)
 
 # Install
-install: build/$(PROG) build/$(PROG).1
+install: build/$(PROG)
 	@echo $(COLOR_GREEN)"Installing AdapterRemoval .."$(COLOR_END)
 	@echo $(COLOR_GREEN)"  .. binary into ${PREFIX}/bin/"$(COLOR_END)
 	$(QUIET) mkdir -p ${PREFIX}/bin/
@@ -109,7 +109,7 @@
 
 	@echo $(COLOR_GREEN)"  .. man-page into ${PREFIX}/share/man/man1/"$(COLOR_END)
 	$(QUIET) mkdir -p ${PREFIX}/share/man/man1/
-	$(QUIET) mv -f build/$(PROG).1 ${PREFIX}/share/man/man1/
+	$(QUIET) cp -a $(PROG).1 ${PREFIX}/share/man/man1/
 	$(QUIET) chmod a+r ${PREFIX}/share/man/man1/$(PROG).1
 
 	@echo $(COLOR_GREEN)"  .. README into ${PREFIX}/share/adapterremoval/"$(COLOR_END)
@@ -141,11 +141,6 @@
 	@echo $(COLOR_GREEN)"Linking static library $@"$(COLOR_END)
 	$(AR) rcs build/$(LIBNAME).a $(LIBOBJS)
 
-build/%.1: %.pod
-	@echo $(COLOR_GREEN)"Constructing man-page $@ from $<"$(COLOR_END)
-	$(QUIET) mkdir -p $(BDIR)
-	$(QUIET) pod2man $< > $@
-
 # Automatic header depencencies
 -include $(DFILES)
 
@@ -154,11 +149,12 @@
 # Unit testing
 #
 TEST_DIR := build/tests
-TEST_OBJS := $(TEST_DIR)/alignment.o \
+TEST_OBJS := $(TEST_DIR)/main_test.o \
+             $(TEST_DIR)/debug.o \
+             $(TEST_DIR)/alignment.o \
              $(TEST_DIR)/alignment_test.o \
              $(TEST_DIR)/argparse.o \
              $(TEST_DIR)/argparse_test.o \
-             $(TEST_DIR)/debug.o \
              $(TEST_DIR)/fastq.o \
              $(TEST_DIR)/fastq_test.o \
              $(TEST_DIR)/fastq_enc.o \
@@ -167,30 +163,21 @@
              $(TEST_DIR)/strutils_test.o
 TEST_DEPS := $(TEST_OBJS:.o=.deps)
 
-GTEST_DIR := googletest-release-1.8.0/googletest
-GTEST_OBJS := $(TEST_DIR)/gtest-all.o $(TEST_DIR)/gtest_main.o
-GTEST_LIB := $(TEST_DIR)/libgtest.a
-
-TEST_CXXFLAGS := -isystem $(GTEST_DIR)/include -I$(GTEST_DIR) -Isrc -DAR_TEST_BUILD -g
-GTEST_CXXFLAGS := $(TEST_CXXFLAGS)
+TEST_CXXFLAGS := -Isrc -DAR_TEST_BUILD -g
 
 test: $(TEST_DIR)/main
-	@echo $(COLOR_GREEN)"Running tests"$(COLOR_END)
-	$(QUIET) $< --gtest_print_time=0 --gtest_shuffle
+	@echo $(COLOR_GREEN)"Running unit tests"$(COLOR_END)
+	$(QUIET) $(TEST_DIR)/main
 
 clean_tests:
 	@echo $(COLOR_GREEN)"Cleaning tests ..."$(COLOR_END)
 	$(QUIET) rm -rvf $(TEST_DIR)
 
-$(TEST_DIR)/main: $(GTEST_LIB) $(TEST_OBJS)
+$(TEST_DIR)/main: $(TEST_OBJS)
 	@echo $(COLOR_GREEN)"Linking executable $@"$(COLOR_END)
 	$(QUIET) $(CXX) $(CXXFLAGS) ${LIBRARIES} $^ -o $@
 
-$(TEST_DIR)/libgtest.a: $(GTEST_OBJS)
-	@echo $(COLOR_GREEN)"Linking GTest library $@"$(COLOR_END)
-	$(QUIET) ar -rv $@ $^
-
-$(TEST_DIR)/%.o: tests/%.cpp
+$(TEST_DIR)/%.o: tests/unit/%.cpp
 	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
 	$(QUIET) mkdir -p $(TEST_DIR)
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
@@ -202,47 +189,34 @@
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
 	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<
 
-$(TEST_DIR)/gtest%.o: $(GTEST_DIR)/src/gtest%.cc
-	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
-	$(QUIET) mkdir -p $(TEST_DIR)
-	$(QUIET) $(CXX) $(GTEST_CXXFLAGS) -c $< -o $@
-
-.PRECIOUS: $(GTEST_DIR)/src/gtest%.cc
-$(GTEST_DIR)/src/gtest%.cc: googletest-release-1.8.0.zip
-	$(QUIET) if ! test -e "$@"; \
-	then \
-		echo $(COLOR_CYAN)"Unpacking Google Test library"$(COLOR_END); \
-		unzip -qo googletest-release-1.8.0.zip; \
-	fi
-
-googletest-release-1.8.0.zip:
-ifneq ("$(shell which wget)", "")
-	@echo $(COLOR_CYAN)"Fetching Google Test library using wget"$(COLOR_END)
-	$(QUIET) wget -q https://github.com/google/googletest/archive/release-1.8.0.zip -O googletest-release-1.8.0.zip
-else ifneq ("$(shell which curl)", "")
-	@echo $(COLOR_CYAN)"Fetching Google Test library using curl"$(COLOR_END)
-	$(QUIET) curl -L https://github.com/google/googletest/archive/release-1.8.0.zip -o googletest-release-1.8.0.zip
-else
-	@echo $(COLOR_YELLOW)"To run tests, first download and unpack GoogleTest 1.8.0 in this folder:"$(COLOR_END)
-	@echo $(COLOR_YELLOW)"  $$ wget https://github.com/google/googletest/archive/release-1.8.0.zip -O googletest-release-1.8.0.zip"$(COLOR_END)
-	@echo $(COLOR_YELLOW)"  $$ unzip googletest-release-1.8.0.zip"$(COLOR_END)
-	@exit 1
-endif
-
 
 #
 # Validation
 #
-VALIDATION_BDIR=build/validation
-VALIDATION_SDIR=validation
-
-validate: build/$(PROG)
-	@echo $(COLOR_CYAN)"Validating AdapterRemoval results"$(COLOR_END)
+VALIDATION_BDIR=./build/regression
+VALIDATION_SDIR=./tests/regression
+
+regression: build/$(PROG)
+	@echo $(COLOR_GREEN)"Running regression tests"$(COLOR_END)
 	@mkdir -p $(VALIDATION_BDIR)
-	@./validation/run $(VALIDATION_BDIR) $(VALIDATION_SDIR)
-
-validation: validate
+	@$(VALIDATION_SDIR)/run $(VALIDATION_BDIR) $(VALIDATION_SDIR)
 
 
 # Automatic header dependencies for tests
 -include $(TEST_DEPS)
+
+
+#
+# Documentation
+#
+SPHINXOPTS  = -n -q
+SPHINXBUILD = sphinx-build
+
+docs:
+	$(QUIET) @$(SPHINXBUILD) -M html docs build/docs $(SPHINXOPTS)
+	$(QUIET) @$(SPHINXBUILD) -M man docs build/docs $(SPHINXOPTS)
+	$(QUIET) cp -v "build/docs/man/AdapterRemoval.1" .
+
+clean_docs:
+	@echo $(COLOR_GREEN)"Cleaning documentation ..."$(COLOR_END)
+	$(QUIET) rm -rvf build/docs

=== debian/changelog ===
adapterremoval (2.2.3-1) unstable; urgency=medium

  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target

 -- Andreas Tille <tille@debian.org>  Sun, 27 Jan 2019 12:29:03 +0100

adapterremoval (2.2.2-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata:
    - Added references to registries
    - yamllint cleanliness

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Fri, 21 Sep 2018 08:19:48 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
            Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 12~),
                zlib1g-dev,
                libbz2-dev,
                libgtest-dev,
                python-markdown
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/adapterremoval.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/adapterremoval.git
+Standards-Version: 4.3.0
+Vcs-Browser: https://salsa.debian.org/med-team/adapterremoval
+Vcs-Git: https://salsa.debian.org/med-team/adapterremoval.git
 Homepage: https://github.com/MikkelSchubert/adapterremoval
 
 Package: adapterremoval

=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,10 @@
 	markdown_py -f README.html README.md
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# dh_auto_test
 	echo "*********** Needs adapting to libgtest-dev. ***************"
+endif
 
 override_dh_auto_install:
 	make PREFIX=$(CURDIR)/debian/$(DEB_SOURCE)/usr

=== debian/watch ===
version=4

https://github.com/MikkelSchubert/adapterremoval/releases .*/archive/v(\d[\d.a-z]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## adapterremoval 2.2.4

=== debian/changelog ===
adapterremoval (2.2.4-1) unstable; urgency=medium

  * New upstream pure bugfix release
  * Run upstream unit tests

 -- Andreas Tille <tille@debian.org>  Thu, 21 Feb 2019 11:22:41 +0100

## adapterremoval 2.3.1

=== Makefile ===
--- 
+++ 
@@ -65,7 +65,9 @@
 LIBNAME  := libadapterremoval
 LIBOBJS  := $(BDIR)/adapterset.o \
             $(BDIR)/alignment.o \
+            $(BDIR)/alignment_tables.o \
             $(BDIR)/argparse.o \
+            $(BDIR)/barcode_table.o \
             $(BDIR)/debug.o \
             $(BDIR)/demultiplex.o \
             $(BDIR)/fastq.o \
@@ -76,6 +78,7 @@
             $(BDIR)/main_adapter_id.o \
             $(BDIR)/main_adapter_rm.o \
             $(BDIR)/main_demultiplex.o \
+            $(BDIR)/managed_writer.o \
             $(BDIR)/scheduler.o \
             $(BDIR)/strutils.o \
             $(BDIR)/threads.o \
@@ -152,9 +155,12 @@
 TEST_OBJS := $(TEST_DIR)/main_test.o \
              $(TEST_DIR)/debug.o \
              $(TEST_DIR)/alignment.o \
+             $(TEST_DIR)/alignment_tables.o \
              $(TEST_DIR)/alignment_test.o \
              $(TEST_DIR)/argparse.o \
              $(TEST_DIR)/argparse_test.o \
+             $(TEST_DIR)/barcodes_test.o \
+             $(TEST_DIR)/barcode_table.o \
              $(TEST_DIR)/fastq.o \
              $(TEST_DIR)/fastq_test.o \
              $(TEST_DIR)/fastq_enc.o \

=== debian/changelog ===
adapterremoval (2.3.1-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * d/copyright: Add upstream contact

  [ Steffen Moeller ]
  * debhelper-compat 12
  * helped by Andreas' routine-update script

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Mar 2019 11:05:51 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
            Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                zlib1g-dev,
                libbz2-dev,
                libgtest-dev,
                python-markdown
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/adapterremoval
 Vcs-Git: https://salsa.debian.org/med-team/adapterremoval.git
 Homepage: https://github.com/MikkelSchubert/adapterremoval

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,8 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# dh_auto_test
-	echo "*********** Needs adapting to libgtest-dev. ***************"
+	make test
+	make clean_tests
 endif
 
 override_dh_auto_install:

## adapterremoval 2.3.2

=== debian/changelog ===
adapterremoval (2.3.2-1ubuntu1) jammy; urgency=medium

  * debian/patches/update-catch2.patch: import catch2 version 2.13.8 to
    fix build failure with glibc 2.34.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Apr 2022 21:54:01 +0000

adapterremoval (2.3.2-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Apply multi-arch hints.
    + adapterremoval-examples: Add Multi-Arch: foreign.
  * Deactivate patches concerning benchmark script since this was removed
    upstream

 -- Andreas Tille <tille@debian.org>  Sun, 29 Aug 2021 07:10:20 +0200

adapterremoval (2.3.1-3) unstable; urgency=medium

  * Fix build on some architectures
    Closes: #923772
  * Set upstream metadata fields: Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Fri, 10 Jan 2020 15:43:41 +0100

adapterremoval (2.3.1-2) unstable; urgency=medium

  * Build-Depends: markdown instead of python-markdown
    Closes: #942927
  * Convert benchmark scripts from Python2 to Python3 using 2to3 even
    if not used in package
  * Standards-Version: 4.4.1
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

 -- Andreas Tille <tille@debian.org>  Sun, 15 Dec 2019 15:21:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
 Source: adapterremoval
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                zlib1g-dev,
                libbz2-dev,
                libgtest-dev,
-               python-markdown
-Standards-Version: 4.4.0
+               markdown
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/adapterremoval
 Vcs-Git: https://salsa.debian.org/med-team/adapterremoval.git
 Homepage: https://github.com/MikkelSchubert/adapterremoval
+Rules-Requires-Root: no
 
 Package: adapterremoval
 Architecture: any
@@ -31,6 +33,7 @@
 Package: adapterremoval-examples
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: rapid adapter trimming, identification, and read merging (example data)
  This program searches for and removes remnant adapter sequences from High-
  Throughput Sequencing (HTS) data and (optionally) trims low quality
@@ -46,7 +49,7 @@
 #Package: adapter-benchmark
 #Architecture: all
 #Depends: ${misc:Depends},
-#         python,
+#         python3,
 #         adapterremoval,
 #         cutadapt,
 #         ea-utils,

=== debian/watch ===
version=4

https://github.com/MikkelSchubert/adapterremoval/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
